


import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;

public class CacheTable implements Serializable 
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public int maxLevel;
	private int minLevel;
	private ArrayList<CacheTableElement> listElement; 

	
	public CacheTable()
	{
		listElement=new ArrayList<CacheTableElement>();
		listElement.add(new CacheTableElement("",1));
	}
	public void upDateCacheTable()
	{
		CacheTableElement[] latestElements=new CacheTableElement[listElement.size()];
		latestElements=listElement.toArray(latestElements);
		listElement.clear();
		String tmpBitKey;
		System.out.println("tmpList size "+ latestElements.length);
		CacheTableElement tmpElement;
		for(int i=0;i<latestElements.length;i++)
		{
			tmpElement=latestElements[i];
			tmpBitKey=0+tmpElement.bitKey;
			System.out.println("tmpKey "+tmpBitKey);
			CacheTableElement newElement=new CacheTableElement(tmpBitKey,tmpElement.nodeId);
			listElement.add(newElement);
			tmpBitKey=1+tmpElement.bitKey;
			newElement=new CacheTableElement(tmpBitKey,tmpElement.nodeId);
			listElement.add(newElement);
		}
		
		for(CacheTableElement element : listElement)
		{
			System.out.println("Update table "+ element.nodeId + "#" + element.bitKey);
		}
		this.maxLevel++;
		
	}
	
	public void splitNode(int oldNode, int newNode)
	{

		System.out.println("New node "+newNode+" Old node "+oldNode);
		System.out.println("listElement size "+ listElement.size());
		System.out.println("Element nr 1 "+ listElement.get(0).nodeId);
		int index=findNodeIndex(0,listElement.size(),oldNode);
		
		if(index==-1)
		{
			System.exit(-1);
		}
		
		if(maxLevel==0)
		{
			upDateCacheTable();
			splitNode(oldNode,newNode);
		}
		else if(listElement.get(index).bitKey.charAt(0)=='0')
		{
			System.out.println("suffixstart  "+ listElement.get(index).bitKey.charAt(0));
			if(listElement.get(index+1).nodeId==oldNode)
			{
				listElement.get(index+1).nodeId=newNode;
			}
			else
			{
				upDateCacheTable();
				splitNode(oldNode,newNode);
			}
		}
		else if(listElement.get(index).bitKey.charAt(0)=='1')
		{
			System.out.println("suffixstart  "+ listElement.get(index).bitKey.charAt(0));
			if(listElement.get(index-1).nodeId==oldNode)
			{
				listElement.get(index-1).nodeId=newNode;
			}
			else
			{
				upDateCacheTable();
				splitNode(oldNode,newNode);
			}
		}

		System.out.println("cTable depth "+ listElement.size());
	}
	
	/*Finds the position in the cache table where the node resides
	 * Search performed as binary search
	 */

	private int findNodeIndex(int start, int end,int nodeId) {
		int middle=((end-start)/2)+start;
		CacheTableElement tmp=listElement.get(middle);
		System.out.println("tmpNodeid "+ tmp.nodeId + "search nodeid "+nodeId);
		for(int i=0;i<listElement.size();i++)
		{
			if(listElement.get(i).nodeId==nodeId)
			{
				return i;
			}
		}
		return -1;
		/**
		if((end-start)<=2)
		{
			tmp=listElement.get(start);
			if(tmp.nodeId==nodeId)
			{
				System.out.println("first tmp "+ tmp.nodeId);
				return start;
			}
			tmp=listElement.get(start+1);
			if(tmp.nodeId==nodeId)
			{
				System.out.println("second tmp "+ tmp.nodeId);
				return start+1;
			}
			return -1;
		}
		if(tmp.nodeId==nodeId)
		{
			return middle;
		}
		else
		{
			
			int search=findNodeIndex(start,middle,nodeId);
			
			if(search!=-1)
				return search;
			
			search=findNodeIndex(middle,end,nodeId);
			if(search!=-1)
				return search;
			
			return-1;	
		}**/
	}
	
	public int seachCacheTable(String bitKey)
	{
		System.out.println("Max level "+maxLevel);
		for(CacheTableElement element : listElement)
		{
			System.out.println("Table element "+ element.bitKey + " " + element.nodeId);
		}
		int nodeId=-1;
		String suffix=bitKey.substring(bitKey.length()-maxLevel);
		for(CacheTableElement element : listElement)
		{
			System.out.println("element "+ element.bitKey + " suffix "+ suffix);
			if(element.bitKey.equals(suffix))
			{	
				nodeId=element.nodeId;
				System.out.println("cTable treff "+ nodeId);
				break;
			}
		}
		//nodeId=binarySearchOnKey(0,listElement.size(),suffix,1);
		return nodeId;
		
	}
	
	private int binarySearchOnKey(int start,int end, String suffix,int numChecks)
	{
		
		if(maxLevel==0)
		{
			return listElement.get(0).nodeId;
		}
		CacheTableElement tmp;
		
		
		
		if((end-start)<=2)
		{
			tmp=listElement.get(start);
			System.out.println("tmp bitKey "+ tmp.bitKey + "suffix "+ suffix);
			if(tmp.bitKey.equals(suffix))
				return tmp.nodeId;
			
			tmp=listElement.get(start+1);
			System.out.println("tmp bitKey "+ tmp.bitKey + "suffix "+ suffix);
			if(tmp.bitKey.equals(suffix))
				return tmp.nodeId;
			
			return -1;
		}
		int middle=((end-start)/2)+start;
		tmp=listElement.get(middle);
		System.out.println("tmp bitKey "+ tmp.bitKey + "suffix "+ suffix);
		System.out.println("NumChecks "+ numChecks);
		int search;
		int checkBit=Integer.parseInt(new String(""+tmp.bitKey.charAt(tmp.bitKey.length()-numChecks)));
		int suffixBit=Integer.parseInt(new String(""+suffix.charAt(suffix.length()-numChecks)));
		System.out.println("Checkbit "+ checkBit);
		System.out.println("Suffixbit "+suffixBit);
		if(tmp.bitKey.equals(suffix))
		{
			return tmp.nodeId;
		}
		else if(checkBit>suffixBit)
		{
			System.out.println("First if clause");
			search=binarySearchOnKey(start, middle,suffix , numChecks+1);
			return search;
		}
		else
		{
			search=binarySearchOnKey(middle,end,suffix,numChecks+1);
			return search;	
		}
	}


	private class CacheTableElement implements Serializable
	{
		String bitKey;
		int nodeId;
		
		CacheTableElement(String bitKey, int nodeId)
		{
			this.bitKey=bitKey;
			this.nodeId=nodeId;
		}
	}

}
