

import java.io.*;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.RemoteException;

import gov2Indexer.TrecIndexing;
import it.unimi.dsi.io.FastBufferedReader;
import it.unimi.dsi.lang.MutableString;
import it.unimi.dsi.mg4j.document.TRECDocumentCollection;
import it.unimi.dsi.mg4j.document.Document;
import it.unimi.dsi.mg4j.document.DocumentIterator;
import java.util.*;

import org.apache.lucene.document.Field;


public class Client 
{
	private int ACTIVE_NODES;
	private SendDocument sender;
	private SendDocument managerSender;
	private int splitPointer;
	private int clusterLevel;
	private CacheTable cTable;
	private String method;
	public boolean isScaling;
	private DistributeDocuments distr;
	private String metadatafil="C:\\luceneIndex\\katalogdata.txt";
	private FileWriter katalogdata;
	private ArrayList<Integer> nodedir;
	private MonitorServer monitor;
	private boolean withIndex;
	private String indexPath="C:\\lucenIndex\\index fil 0-30";
	private int docCount;
	private int failedRecipient;
		
	
	public Client(String method,boolean withIndex)
	{
		isScaling=false;
		distr=new DistributeDocuments(method);
		this.method=method;
		this.withIndex=withIndex;
		try {
			Naming.rebind("rmi://localhost:1099/UpdateClientImage",new UpdateClusterImage(this));
			Naming.rebind("rmi://localhost:1099/HoldIndexing",new UpdateClusterImage(this));
			
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		ACTIVE_NODES=1;
		splitPointer=1;
		clusterLevel=0;
		cTable=new CacheTable();
		nodedir=new ArrayList<Integer>();
		nodedir.add(0,1);
		docCount=0;
		failedRecipient=0;
		
	}
	public void createDocuments()
	{
		   docCount = 0;
		   TrecIndexing indexer=new TrecIndexing();
		   File trec=new File("G:\\gov2-corpus");
		   try 
		   {
			   katalogdata=new FileWriter(new File(metadatafil));
		   } catch (IOException e1) {
			// TODO Auto-generated catch block
			   e1.printStackTrace();
		   }
		   File[] gov2=trec.listFiles();
		   
		   
		   for(int i=0;i<20;i++)
		   {
			   
			   int clusterLoad=-1;
			   File [] gov2Dir=gov2[i].listFiles();
			   String [] govPath=new String[gov2Dir.length];
			   for(int j=0;j<govPath.length;j++)
			   {
				   govPath[j]=gov2Dir[j].getAbsolutePath();
				   System.out.println("govpath "+govPath[j]);
			   }
			   
			   TRECDocumentCollection trecColl=indexer.parseGov2(govPath);
				   
			   try
			   {
				 DocumentIterator itr=trecColl.iterator();
				 katalogdata.append("Katalogdata "+i+" \n");
				 katalogdata.append("trecColl size "+trecColl.size());
				 katalogdata.flush();
		
				   System.out.println("Collection size "+ trecColl.size());
				   it.unimi.dsi.mg4j.document.Document doc;
				   System.out.println("writing files");
				 
				   sender=new SendDocument(4444,null);
				   managerSender=new SendDocument(5555,null);
				   while((doc=itr.nextDocument())!=null)
				   {	
					   docCount++;
					   while(isScaling==true)
					   {
						   
					   }

					   System.out.println("Catalog nr " + i + "DocCount "+ docCount);

					   synchronized(sender)
					   {
						   if(withIndex==true)
						   {
							   createLuceneDoc(doc);
						   }
						   else
						   {
							   int node=findStorageNode(Math.abs(doc.uri().hashCode()));
							   System.out.println("Sending to node " + node);
							   if(method.equalsIgnoreCase("xfs"))
							   {
								   managerSender.sendFromClient(doc,node);
							   }
							   else
							   {
								   sender.sendFromClient(doc,node);
							   }
						   }
					   } 	 
					   
					   if(method.equalsIgnoreCase("lh"))
					   {
						   clusterLoad=125000*monitor.getACTIVE_NODES();
						   if((clusterLoad*0.75)<=docCount)
						   {
							   monitor.setPastLimit(true);
						   }
					   }
				   }

				   System.out.println("Transport complete");
				   
				 /**  long starttime=System.currentTimeMillis();
				   long stoptime;
				   while(true)
				   {	
					  stoptime=System.currentTimeMillis();
					  if((stoptime-starttime)>5000)
							  break;
				   }
				   
				   int[] loadBalance=new int[7];
				   int tmp,nodenr;
				   for(int c=1;c<=6;c++)
				   {
					   nodenr=c;
					   if(c>3)
					   {
						   nodenr++;
					   }
					   								//Naming.lookup("rmi://endless0"+i+".idi.ntnu.no/Scaling");
					   ReportDocCountInterface rdc;
					   rdc=(ReportDocCountInterface)Naming.lookup("rmi://endless0"+nodenr+".idi.ntnu.no/GetDocCount");
					   loadBalance[c]=rdc.getDocCount(ACTIVE_NODES);
					   tmp=rdc.getDocCount(ACTIVE_NODES);
					   
					   
					   System.out.println("DocCount node "+ c + "=" + tmp);
				   }**/
				   trecColl.close();
				   
				  
				   
			   }
			   catch(Exception e)
			   {
				   System.out.println(e.getMessage());
				   e.printStackTrace();
			   }
			   finally
			   {
				   try {
						trecColl.close();
						//sender.closeConnection();
				   } catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				   }
			   }//end finally
		   }// end for-loop iterating document directories
		  
	
	}//end createDocuments method
	
		   
		   public static void main(String[] args)
		   {
			   Client c=new Client("rangepartition",false);
			   c.createDocuments();
		   }
		   
			public int findStorageNode(int nodeId)
			{
				int node=0;
				if(method.equalsIgnoreCase("lh"))
				{
					distr.initLH(ACTIVE_NODES, clusterLevel);
				}
				else if(method.equalsIgnoreCase("eh"))
				{
					distr.initEH(cTable);
				}
				else if(method.equalsIgnoreCase("rush"))
				{
					distr.initRush(ACTIVE_NODES);
				}
				else if(method.equalsIgnoreCase("rangepartition"))
				{
					distr.initRangepartitioning(nodedir, ACTIVE_NODES);
				}
				else if(method.equalsIgnoreCase("scaddar"))
				{
					distr.initSCADDAR(ACTIVE_NODES);
					/**node=(int)(ACTIVE_NODES * Math.random()) + 1;
					if(node>3)
						node++;
					return node;*/
				}
				else if(method.equalsIgnoreCase("xfs"))
				{		
					distr.initRangepartitioning(nodedir, ACTIVE_NODES);
				}
				

				node=distr.findNode(nodeId);
				
				if(method.equalsIgnoreCase("lh"))
				{
					if(node<splitPointer)
					{
						distr.initLH(ACTIVE_NODES, clusterLevel+1);
						node=distr.findNode(nodeId);
					
					}
				}
				if(node>3)
					node++;
				//if(node<1)
				//{
				//	node=(int)(ACTIVE_NODES * Math.random()) + 1;
				//}
				

				return node;
			}
			
			public void createLuceneDoc(it.unimi.dsi.mg4j.document.Document mgDoc)
			{
				System.out.println("Sending with index");
				org.apache.lucene.document.Document doc = new org.apache.lucene.document.Document();
				String docContent=null;
				FastBufferedReader r=null;
				char prev,l;
				int c;
				try {
					r = (FastBufferedReader)mgDoc.content(0);

				MutableString parsedContent=new MutableString();
	       		r.readLine(parsedContent);
	    		prev = ' ';
	    		while( (c = r.read()) != -1) 
	    		{
	    			l = (char) c;
	    			if (prev == ' ' && l == ' ')
	    				continue; // vil ikkje ha repeterende mellomrom!
	    			if ((prev=='\n' && l == '\n')  || l == '\r' || l=='\t') 
	    			{
	    				continue;
	    			}
	    		
	    			parsedContent.append(l);
	    			prev = l;
			   
	    		}
	    		
	    		docContent=parsedContent.toString();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	    		 
	    		
				   doc.add(new Field("url",mgDoc.uri().toString(),Field.Store.COMPRESS,Field.Index.NOT_ANALYZED));
				   doc.add(new Field("docId",new Integer(Math.abs(mgDoc.uri().hashCode())).toString(),Field.Store.COMPRESS,Field.Index.NOT_ANALYZED));
				   doc.add(new Field("title",mgDoc.title().toString(),Field.Store.COMPRESS,Field.Index.NOT_ANALYZED));
				   doc.add(new Field("content",docContent,Field.Store.NO,Field.Index.ANALYZED));
				   
				   int node=findStorageNode(Integer.parseInt(doc.get("docId")));
				   System.out.println("Sending to node " + node);
				   if(method.equalsIgnoreCase("xfs"))
				   {
					   managerSender.sendWithIndex(doc, docContent, node, indexPath,true);
				   }
				   else
				   {
					   System.out.println("Index Sender");
					   sender.sendWithIndex(doc, docContent, node, indexPath,true);
				   }
			}
			public int getSplitPointer() {
				return splitPointer;
			}
			public void setSplitPointer(int splitPointer) {
				this.splitPointer = splitPointer;
			}
			public int getClusterLevel() {
				return clusterLevel;
			}
			public void setClusterLevel(int clusterLevel) {
				this.clusterLevel = clusterLevel;
			}
			public void setCTable(CacheTable table) {
				cTable = table;
			}
			public CacheTable getCTable() {
				return cTable;
			}
			public void setACTIVE_NODES(int active_nodes) {
				ACTIVE_NODES = active_nodes;
			}
			public void setDirectory(ArrayList<Integer> directory)
			{
				this.nodedir=directory;
			}
			
			public void addMonitor(MonitorServer monitor)
			{
				this.monitor=monitor;
			}
			public int getDocCount() {
				return docCount;
			}
			public int getFailedRecipient() {
				return failedRecipient;
			}
			public void increaseFailedRecipient() {
				failedRecipient++;
			}
			
			


}
