import java.util.*;






public class DistributeDocuments 
{
	private String method;
	private int activeNodes;
	private int clusterLevel;
	private CacheTable cTable;
	private double[] nodeWeights;
	private double[] cumulativeWeights;
	private ArrayList<Integer> directory;

	
	public DistributeDocuments(String method)
	{
		this.method=method;
		
	}
	
	
	public void initLH(int activeNodes,int clusterLevel)
	{
		this.activeNodes=activeNodes;
		this.clusterLevel=clusterLevel;
	}
	
	public void initEH(CacheTable cTable)
	{
		this.cTable=cTable;
	}
	
	public void initSCADDAR(int activeNodes)
	{
		this.activeNodes=activeNodes;
	}
	
	 public void initRush(int activeNodes)
	 {
		 this.activeNodes=activeNodes;
		 nodeWeights=new double[activeNodes];
		 cumulativeWeights=new double[activeNodes];
		 for(int j=0;j<activeNodes;j++)
		 {
			 
			 if(j==0)
			 {
				 nodeWeights[j]=1;
				 cumulativeWeights[j]=0;
			 }
			 else
			 {
				 nodeWeights[j]=nodeWeights[j-1]*(1.1);
				 cumulativeWeights[j]=cumulativeWeights[j-1]+nodeWeights[j-1];
			 }
		 }
	 }
	 
	 public void initRangepartitioning(ArrayList<Integer> directory,int activeNodes)
	 {
		 this.directory=directory;
		 this.activeNodes=activeNodes;
	 }
	public int findNode(int docId)
	{
		if(method.equalsIgnoreCase("LH"))
		{
			return linearHashing(docId);
		}
		else if(method.equalsIgnoreCase("EH"))
		{
			return extendibleHashing(docId);
		}
		else if(method.equalsIgnoreCase("SCADDAR"))
		{
			return scaddar(docId);
		}
		else if(method.equalsIgnoreCase("RUSH"))
		{
			return rush(docId,1);
		}
		else if(method.equalsIgnoreCase("RangePartition"))
		{
			return rangePartition(docId);
		}
		else if(method.equalsIgnoreCase("xFS"))
		{
			return rangePartition(docId);
		}
		return -1;
	}
	
	public int linearHashing(int docId)
	{  
		int node=0;
		int modulus=(int)(Math.pow((int)2,(int)clusterLevel));
		
		if(modulus==0)
			modulus=1;
		node=docId%modulus;
		//node=node%activeNodes;
		node+=1;
		System.out.println("DocId "+ docId + " # modulus "+ modulus +" # node "+node);
		return node;
	}
	
	public int extendibleHashing(int docId)
	{
		System.out.println("DocId "+ docId);
		String bitKey=Integer.toBinaryString(docId);
		int node=cTable.seachCacheTable(bitKey);
		return node;
	}
	

	public int scaddar(int docId)
	{
		System.out.println("activeNodes "+activeNodes);
		int pseudoKey,node;
		pseudoKey=docId;
		node=1;
		if(activeNodes==1)
		{
			return 1;
		}
		for(int i=2;i<=activeNodes;i++)
		{
			/*********
			 * First alternative Bounded SCADDAR
			 * Second alternative Randomized SCADDAR
			 */
			
			
			if(((pseudoKey/(i-1))%i)<(i-1))
			{
				pseudoKey=((pseudoKey/(i-1))-(pseudoKey/(i-1))%i)+(pseudoKey%(i-1));
			}
			else
			{
				pseudoKey=pseudoKey/(i-1);
			}
			
			
			
			/**if((pseudoKey%i)<(i-1))
			{
				pseudoKey=pseudoKey*i+(pseudoKey%(i-1));
			}
			else
			{
				pseudoKey=pseudoKey*i+(pseudoKey%i);
			}**/
		}
		
		
		
		node=pseudoKey%activeNodes;
		/**int nodeCount=activeNodes;
		boolean stop=false;
		while(!stop)
		{
			if(nodeCount==1)
			{
				break;
			}
			if(node<nodeCount-1)
			{
				nodeCount--;
				node=pseudoKey%nodeCount;
			}
			else
			{
				stop=true;
			}
		}**/
		node+=1;
		System.out.println("Scaddar node "+ node);
		return node;
	}
	
	//The make the testing of this method simiar to the other methods the numReplicas is set to 1 and a singel node acts as a standard RUSH cluster
	public int rush(int docId,int numReplicas)
	{
		System.out.println("Rush active nodes "+activeNodes);
		int storageNode=0;;
		for(int j=activeNodes-1;j>=0;j--)
		{	System.out.println("Value j" + j);
			double t=Math.max(0,numReplicas-cumulativeWeights[j]); // The is used as a modifier for some of the parameters
			int replicasPrNode=(int)t+hypergeometricDraw(numReplicas-t,cumulativeWeights[j]-t,cumulativeWeights[j]+nodeWeights[j],nodeWeights[j],docId,j);
			System.out.println("Num replicas node "+j+" "+replicasPrNode);
			if(replicasPrNode>0)
			{
				storageNode=j;
				break;
			}
			if(j==0)
			{
				storageNode=0;
			}
		}
		storageNode+=1;
		System.out.println("Storage Node "+storageNode);
		return storageNode;
	}

	public int rangePartition(int docId)
	{
		for(int n : directory)
		{
			System.out.println("Directory element "+n );
		}
		int node=Integer.MAX_VALUE/activeNodes;
		boolean seaching=true;
		int partition=1;
		while(seaching || ((node*partition)<=Integer.MAX_VALUE))
		{
			if(docId<(node*partition))
			{
				break;
			}
			else
			{
				partition++;
			}
		}
		//return partition;
		System.out.println("Partition "+partition);
		if((partition-1)<directory.size())
		{
			return directory.get(partition-1);
		}
		else
		{
			return directory.get(directory.size()-1);
		}

	}
	public int xfs(int docId)
	{
		return 0;
	}
	
	private int hypergeometricDraw(double d,double defectDraws,double totalSet,double e,int docId,int cluster)
	{
		System.out.println("numDraws "+d+" defectDraws "+defectDraws+" totalSet "+totalSet);
		int drawSuccess=0;
		double z; //used for random number
		for(int i=0;i<d;i++)
		{
			z=randomNumberGenerator(docId,cluster);
			double mappingProb=(double)(defectDraws/totalSet); 
			System.out.println("Random value "+ z +" mapping prob "+mappingProb);
			if(z>=mappingProb)
			{
				System.out.println("Mapping to node ");
				drawSuccess++;
				defectDraws-=1;
				break;
			}
			totalSet-=1;
		}
		return drawSuccess;
	}
	
	/*******
	 * 
	 * @return a random number between 0 and 1
	 *******/
	private double randomNumberGenerator(int seed,int steps)
	{
		double randomNumber=0;
		Random r=new Random(seed);
		for(int i=0;i<steps;i++)
		{
			randomNumber=r.nextDouble();
		}
		
		return randomNumber;
	}
	

}
