
import gov2Indexer.TrecIndexing;
import it.unimi.dsi.mg4j.document.Document;
import it.unimi.dsi.mg4j.document.DocumentIterator;
import it.unimi.dsi.mg4j.document.TRECDocumentCollection;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.net.MalformedURLException;

import java.rmi.Naming;
import java.rmi.NotBoundException;

import java.rmi.RemoteException;

import java.util.*;





public class MonitorServer 
{
	private int ACTIVE_NODES;
	private boolean scaling;
	private SendDocument sender;
	private int splitPointer;
	private int clusterLevel;
	private String method;
	private Client client;
	private ArrayList<Integer> nodedir;
	private int systemDocCount;
	private boolean pastLimit;
	private String lastdatafil="Z:\\dokument\\Experimentdata\\lastbalanse.txt";
	private String timedatafil="Z:\\dokument\\Experimentdata\\indexeffekt.txt";
	private FileWriter lastdata;
	private FileWriter timedata;
	private int prevDocCount;
	private long timer;
	
	public MonitorServer(String method,Client client) throws RemoteException {
		this.method=method;
		this.client=client;
		try {

			Naming.rebind("rmi://localhost:1099/Scaling",new AddNodeMonitorServer(this));

		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		prevDocCount=0;
		systemDocCount=0;
		ACTIVE_NODES=1;
		scaling=false;
		splitPointer=1;
		clusterLevel=0;
		nodedir=new ArrayList<Integer>();
		nodedir.add(1);
		pastLimit=false;
		timer=new Date().getTime();
		try {
			lastdata=new FileWriter(new File(lastdatafil));
			timedata=new FileWriter(new File(timedatafil));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		// TODO Auto-generated constructor stub
	}


	public int getACTIVE_NODES() {
		return ACTIVE_NODES;
	}


	/**public void createDocuments()
	{

		   TrecIndexing indexer=new TrecIndexing();
		   File trec=new File("F:\\gov2-corpus");
		   File[] gov2=trec.listFiles();
		   
		   
		   for(int i=0;i<1;i++)
		   {
			   
			   File [] gov2Dir=gov2[i].listFiles();
			   String [] govPath=new String[gov2Dir.length/25];
			   for(int j=0;j<govPath.length;j++)
			   {
				   govPath[j]=gov2Dir[j].getAbsolutePath();
				   System.out.println("govpath "+govPath[j]);
			   }
			   TRECDocumentCollection trecColl=indexer.parseGov2(govPath);
				   
			   try
			   {
				   DocumentIterator itr=trecColl.iterator();
				  // FastBufferedReader r=null;
				   //char prev,l;
				   //int c;

				   System.out.println("Collection size "+ trecColl.size());
				   it.unimi.dsi.mg4j.document.Document doc;
				   System.out.println("writing files");
				   //MutableString parsedContent=new MutableString();
				   //Document[] docArray=new Document[trecColl.size()];
				   //int docCount=0;
				   sender=new SendDocument(4444,null);
				   while((doc=itr.nextDocument())!=null)
				   {						   

					   //receivingNode="endless0"+findStorageNode(doc)+".idi.ntnu.no";
					   
					   while(isScaling())
					   {
						   //pause in document sending until the nodes have finished the repartitioning
					   }
					   
					   synchronized(sender)
					   {
						   sender.sendFromClient(doc,findStorageNode(doc));
					   }
				   	   //sender.closeConnection();
				   }

				   System.out.println("Transport complete");
				   
				   long starttime=System.currentTimeMillis();
				   long stoptime;
				   while(true)
				   {	
					  stoptime=System.currentTimeMillis();
					  if((stoptime-starttime)>5000)
							  break;
				   }
				   
				   int[] loadBalance=new int[7];
				   int tmp,nodenr;
				   for(int c=1;c<=6;c++)
				   {
					   nodenr=c;
					   if(c>3)
					   {
						   nodenr++;
					   }
					   								//Naming.lookup("rmi://endless0"+i+".idi.ntnu.no/Scaling");
					   ReportDocCountInterface rdc;
					   rdc=(ReportDocCountInterface)Naming.lookup("rmi://endless0"+nodenr+".idi.ntnu.no/GetDocCount");
					   loadBalance[c]=rdc.getDocCount();
					   tmp=rdc.getDocCount();
					   
					   lastdata.write("DocCount node "+ c + "="+tmp);
					   System.out.println("DocCount node "+ c + "=" + tmp);
				   }
				   
				  
				   
			   }
			   catch(Exception e)
			   {
				   System.out.println(e.getMessage());
			   }
			   finally
			   {
				   try {
						trecColl.close();
						//sender.closeConnection();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			   }
		   }
			   
		
		   //out.close();
	   	   //clientSocket.close();

	}**/
	
	public int findStorageNode(Document doc)
	{
		int node=0;
		int nodeId=Math.abs(doc.uri().hashCode());
		
		node=(int)(ACTIVE_NODES * Math.random()) + 1;

		/*
		boolean partitioning=true;
		while(partitioning)
		{
			node++;
			if(nodeId<(Integer.MAX_VALUE/ACTIVE_NODES)*(node))
			{
				partitioning=false;
			}
			
		}
		if(node>3)
			node+=1;
		//node=(int) (nodeId%ACTIVE_NODES);
		System.out.println("findStorageNode "+node);
		//node=1;*/
		return node;
	}
	
	/*public org.apache.lucene.document.Document createLuceneDoc(it.unimi.dsi.mg4j.document.Document doc)
	{
		org.apache.lucene.document.Document returnDoc=new org.apache.lucene.document.Document();
		String docContent,docTitle,docUrl,docId=null;
		FastBufferedReader r=null;
		char prev,l;
		int c;
		try {
			r = (FastBufferedReader)doc.content(0);

			MutableString parsedContent=new MutableString();
   			r.readLine(parsedContent);
   			prev = ' ';
			while( (c = r.read()) != -1) 
			{
				l = (char) c;
			if (prev == ' ' && l == ' ')
				continue; // vil ikke ha repeterende mellomrom!
				if ((prev=='\n' && l == '\n')  || l == '\r' || l=='\t') 
				{
					continue;
				}
		
				parsedContent.append(l);
				prev = l;
	   
			}
			docContent=parsedContent.toString();
			returnDoc.add(new Field("url",doc.uri().toString(),Field.Store.COMPRESS,Field.Index.NOT_ANALYZED));
			returnDoc.add(new Field("docId",new Integer(Math.abs(doc.uri().toString().hashCode())).toString(),Field.Store.COMPRESS,Field.Index.NOT_ANALYZED));
			returnDoc.add(new Field("title",doc.title().toString(),Field.Store.COMPRESS,Field.Index.NOT_ANALYZED));
			returnDoc.add(new Field("content",docContent,Field.Store.NO,Field.Index.ANALYZED));
			
		} catch (IOException e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
		
		return returnDoc;
	}*/
	   public long longHashCode(String s)
	   {
		   long hashCode = 0;  
		   int len = s.length();  
		   for (int i = 0; i < len; i++)
		   {
			   hashCode =hashCode + s.charAt(i)*(int)Math.pow(31,len-i);
		   }
		   
		   return hashCode;
	   }
	
	public static void main(String[] args)
	{
		MonitorServer monitor = null;
		try {
			monitor = new MonitorServer("rangepartition",new Client("rangepartition",false));
			monitor.client.addMonitor(monitor);
			monitor.client.createDocuments();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//monitor.createDocuments();
	}

	public void addNode(int nodeId) throws RemoteException 
	{
		
		if(!isPastLimit() && method.equalsIgnoreCase("lh"))
		{
			return;
		}
		if(!isScaling())
		{
			System.out.println("Adding new node : num nodes " + ACTIVE_NODES);
			client.isScaling=true;
			scaling=true;

			
			int scalingStatus=0;
			if(ACTIVE_NODES==6)
			{	
				
				int[] loadBalance=new int[7];
				   int tmp,nodenr;
				   for(int c=1;c<=6;c++)
				   {
					   nodenr=c;
					   if(c>3)
					   {
						   nodenr++;
					   }
					   								//Naming.lookup("rmi://endless0"+i+".idi.ntnu.no/Scaling");
					   ReportDocCountInterface rdc = null;
					   try {
						rdc=(ReportDocCountInterface)Naming.lookup("rmi://endless0"+nodenr+".idi.ntnu.no/GetDocCount");
					} catch (MalformedURLException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (NotBoundException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					   loadBalance[c]=rdc.getDocCount(ACTIVE_NODES);
					   tmp=rdc.getDocCount(ACTIVE_NODES);
					   
					   
					   System.out.println("DocCount node "+ c + "=" + tmp);
					   
					   try {
						lastdata.write("Node "+c+"="+tmp+"\n");
						lastdata.flush();
						writeLogg();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					 
				   }
				  System.out.println("Client wrong lookup "+ client.getFailedRecipient());
				System.exit(1);
				return;
			}
			writeLogg();
			
			
			
			
			if(method.equalsIgnoreCase("lh"))
			{
				linearHashing();
			}
			else if(method.equalsIgnoreCase("eh"))
			{
				extendibleHashing(nodeId);
			}
			else if(method.equalsIgnoreCase("scaddar"))
			{
				scaddar();
			}
			else if(method.equalsIgnoreCase("rush"))
			{
				rush(ACTIVE_NODES+1);
			}
			else if(method.equalsIgnoreCase("rangepartition"))
			{
				nodedir.trimToSize();
				System.out.println("Directory size "+ nodedir.size());
				if(nodedir.size()==1)
				{
					nodedir.add(ACTIVE_NODES+1);
				}
				else
				{
					nodedir.add(nodedir.size()/2,ACTIVE_NODES+1);
				}
				System.out.println("Range partitioning");
				rangepartition(nodedir);
			}
			else if(method.equalsIgnoreCase("xfs"))
			{
				xfs(nodedir);
			}
				ACTIVE_NODES++;
				scaling=false;
				setPastLimit(false);
				client.isScaling=false;
				timer=new Date().getTime();

		}
		
		
		// TODO Auto-generated method stub
		
	}


	/**
	 * 
	 */
	private void writeLogg() {
		int newDocCount=client.getDocCount()-prevDocCount;
		prevDocCount=client.getDocCount();
		long newTime=new Date().getTime()-timer;
		timer=new Date().getTime();

		try {
			timedata.write("Active nodes " + ACTIVE_NODES+": ");
			timedata.write("New documents "+newDocCount+" ");
			timedata.write("Timer "+newTime+"\n");
			timedata.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}


	private void xfs(ArrayList<Integer> dir) {
		System.out.println("Cluster growing");
		for(int i=0;i<nodedir.size();i++)
		{
			int nodenr=nodedir.get(i);
			if(nodenr>3)
				nodenr++;
			System.out.println("Updating node "+nodenr);
			AddNodeInterface ad;
			try {
				ad=(AddNodeInterface)Naming.lookup("rmi://endless0"+nodenr+".idi.ntnu.no/Scaling");

			ad.addNodeXfs(ACTIVE_NODES+1,dir);
			System.out.println("Active Nodes "+ (ACTIVE_NODES+1));
			
			} catch (MalformedURLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (RemoteException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NotBoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}


	private void rangepartition(ArrayList<Integer> dir) 
	{
		System.out.println("Cluster growing");
		for(int i=ACTIVE_NODES+1;i>0;i--)
		{
			int nodenr=i;
			if(nodenr>3)
				nodenr++;
			System.out.println("Updating node "+nodenr);
			AddNodeInterface ad;
			try {
				ad=(AddNodeInterface)Naming.lookup("rmi://endless0"+nodenr+".idi.ntnu.no/Scaling");

			ad.addNodeRangepartitioning(ACTIVE_NODES+1,dir);
			System.out.println("Active Nodes "+ (ACTIVE_NODES+1));
			
			} catch (MalformedURLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (RemoteException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NotBoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		for(int i=ACTIVE_NODES+1;i>0;i--)
		{
			int nodenr=i;
			if(nodenr>3)
				nodenr++;
			System.out.println("Repartitioning node "+nodenr);
			AddNodeInterface ad;
			try {
				ad=(AddNodeInterface)Naming.lookup("rmi://endless0"+nodenr+".idi.ntnu.no/Scaling");
			ad.redistribute();
			
			} catch (MalformedURLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (RemoteException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NotBoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		
		
	}


	private void rush(int activeNodes) {
		try
		{
			for(int i=1;i<=activeNodes;i++)
			{
				int nodenr=i;
					if(nodenr>3)
					{
						nodenr+=1;
					}
					System.out.println("nodenr "+ nodenr);
					AddNodeInterface ad;
						ad = (AddNodeInterface)Naming.lookup("rmi://endless0"+nodenr+".idi.ntnu.no/Scaling");
						ad.addNodeRush(activeNodes);
						
			}
			for(int i=1;i<=activeNodes;i++)
			{
				int nodenr=i;
				if(nodenr>3)
				{
					nodenr+=1;
				}
				AddNodeInterface ad;
				ad = (AddNodeInterface)Naming.lookup("rmi://endless0"+nodenr+".idi.ntnu.no/Scaling");
				ad.redistribute();
			}
		}
		catch(Exception e)
		{
			System.out.println(e.getStackTrace());
		}
		
	}


	private void scaddar() {
		for(int i=0;i<=ACTIVE_NODES;i++)
		{
			int nodenr=i+1;
				if(nodenr>3)
				{
					nodenr+=1;
				}
				AddNodeInterface ad;
				try {
					ad = (AddNodeInterface)Naming.lookup("rmi://endless0"+nodenr+".idi.ntnu.no/Scaling");
					ad.addNodeScaddar(ACTIVE_NODES+1);
				} catch (MalformedURLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (RemoteException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NotBoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		}
		
		for(int i=0;i<=ACTIVE_NODES;i++)
		{
			int nodenr=i+1;
				if(nodenr>3)
				{
					nodenr+=1;
				}
				AddNodeInterface ad;
				try {
					ad = (AddNodeInterface)Naming.lookup("rmi://endless0"+nodenr+".idi.ntnu.no/Scaling");
					ad.redistribute();
				} catch (MalformedURLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (RemoteException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NotBoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		}
		client.setACTIVE_NODES(ACTIVE_NODES+1);
		
	}


	private void extendibleHashing(int nodeId)
	{
		AddNodeInterface ad;
		try {
			int newNode=ACTIVE_NODES+1;
			ad = (AddNodeInterface)Naming.lookup("rmi://endless0"+nodeId+".idi.ntnu.no/Scaling");
			ad.addNodeExtendibleHashing(ACTIVE_NODES+1,nodeId,newNode);
			
			//ad = (AddNodeInterface)Naming.lookup("rmi://endless0"+newNode+".idi.ntnu.no/Scaling");
			//ad.addNodeExtendibleHashing(nodeId,newNode);
			
			
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NotBoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		
	}


	/**
	 * @throws RemoteException
	 */
	private void linearHashing() throws RemoteException {
		
		try {
			
			AddNodeInterface adOld,adNew;
			System.out.println("Cluster growing");
			System.out.println("Start scaling node " + splitPointer);
			int newNode=ACTIVE_NODES+1;
			
			if(newNode>3)
				newNode+=1;
			adNew = (AddNodeInterface)Naming.lookup("rmi://endless0"+newNode+".idi.ntnu.no/Scaling");
			
			
			if(ACTIVE_NODES>=(int)Math.pow(2,clusterLevel))
			{
				splitPointer=1;
				clusterLevel++;
				adOld = (AddNodeInterface)Naming.lookup("rmi://endless0"+splitPointer+".idi.ntnu.no/Scaling");
				splitPointer++;
					
			}
			else
			{
				adOld = (AddNodeInterface)Naming.lookup("rmi://endless0"+splitPointer+".idi.ntnu.no/Scaling");
				splitPointer++;
			}
			adNew.addNodeLinearHashing(clusterLevel,ACTIVE_NODES+1);
			adOld.addNodeLinearHashing(clusterLevel,ACTIVE_NODES+1);
			

			
			System.out.println("newNode "+ newNode);

			System.out.println("Splitpointer "+ splitPointer);
			System.out.println("Cluster level" +clusterLevel);
			

			
			
			
			
			

		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NotBoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		//}


	}
	
	public boolean isScaling()
	{
		return scaling;
	}
	
	public void incrementSystemDocCount()
	{
		systemDocCount++;
	}


	public boolean isPastLimit() {
		return pastLimit;
	}


	public void setPastLimit(boolean pastLimit) {
		this.pastLimit = pastLimit;
	}
}



