


//import it.unimi.dsi.lang.MutableString;

import java.net.*;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Date;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.io.*;

import org.apache.lucene.index.*;
import org.apache.lucene.document.*;

public class ReceiveDocumentsThread implements Runnable
{
	private ServerSocket server;
	private Socket socket=null;
	private StorageNode sNode;
	private final ExecutorService pool;
	private boolean withIndex;

	
	public ReceiveDocumentsThread(ServerSocket server,StorageNode sNode,boolean withIndex)
	{
		//this.socket=socket;
		this.server=server;
		this.sNode=sNode;
		pool = Executors.newFixedThreadPool(50);
		this.withIndex=withIndex;

	}
	
	
	public void run()
	{
		
		try {
			socket=server.accept();
			pool.execute(new Handler(socket));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		pool.shutdown();
	}
	
	class Handler implements Runnable
	{
		private final Socket socket;
	
		Handler(Socket socket)
		{
			this.socket=socket;
			//socket.setReuseAddress(true);
		

		}
	
		public void run()
		{
			//System.out.println("Socket server running");
			String docContent="",docUrl="", docTitle ="";
			File gov2File=null;
			String filePath="/mnt/d1/hoyum/documents";
			String indexPath="/mnt/d1/hoyum/index";
			ObjectInputStream in;
			BufferedReader reader;
			Document doc = null;
			int contentLength;
			InetAddress endpoint=socket.getInetAddress();
			
		
			try
			{
				//in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
				
				boolean listening=true,reading=false;
				boolean correctNode=false;
				
				while(listening)
				{
					
					if(withIndex==false || !endpoint.getHostName().startsWith("endless"))
					{
						in=new ObjectInputStream(socket.getInputStream());
					//in.read()!=-1
					synchronized(in)
					{
						
						
						//docMetadata=in.readLine();
						
						
							try
							{
								docTitle=(String)in.readObject();
							}
							catch(IOException i)
							{
								System.out.println(" Exception reading title "+ i.getMessage());
								i.printStackTrace();
							} catch (ClassNotFoundException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
						
							reading=true;

							
							System.out.println("Start reading");
							System.out.println("docTitile "+docTitle);					
							contentLength=in.readInt();						
							//System.out.println("Content length "+ contentLength);
							docUrl=(String)in.readObject();
					
					
							//char[] inputArray=new char[contentLength];
							int c;
							ArrayList<Character> inputArray=new ArrayList<Character>();
							for(int i=0;i<contentLength;i++)
							{
								c=in.readChar();
								Character element=new Character((char)c);
								inputArray.add(element);
							}
							
							System.out.println("InputArray size "+inputArray.size());
							inputArray.trimToSize();
							char[] charArray=new char[inputArray.size()];
							
			
							for(int i=0;i<inputArray.size();i++)
							{
								charArray[i]=inputArray.get(i).charValue();
							}
							inputArray=null;
						//InputStreamReader inReader=new InputStreamReader(socket.getInputStream());
						//System.out.println("chars read "+in.read(inputArray,0,inputArray.length));
							//docContent=new String(charArray);

							doc = createDocument(docContent, docUrl, docTitle);
						


						
						reading=false;
					
					}// end if read!=-1
					}
					else
					{
						ObjectInputStream objectReader=new ObjectInputStream(socket.getInputStream());
						System.out.println("Creating ObjectInputStream");
						try {
							doc=(Document)objectReader.readObject();
							docContent=(String)objectReader.readObject();
							
						} catch (ClassNotFoundException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					}
					correctNode=checkCorrectness(doc,docContent);
					if(correctNode==true)
					{
						System.out.println("Correct node");
						sNode.loggingDocCount++;
						gov2File=new File(filePath+"/"+docTitle+".txt");
					
						FileWriter writer=new FileWriter(gov2File);
						writer.write(docContent);
					
					
						writer.close();
					

					
						indexDocument(doc);
					 
					
						System.out.println("Retrieved docs"+ sNode.docCount());
					}
					correctNode=false;
					doc=null;
//
				}//end while
			
			}
			catch(IOException ioe)
			{
				System.out.println("IOException " + ioe.getMessage());
				ioe.printStackTrace();
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		/**
		 * @param docContent
		 * @param docUrl
		 * @param docTitle
		 * @return
		 */
		private Document createDocument(String docContent, String docUrl,
				String docTitle) {
			Document doc=new Document();
			   
			   doc.add(new Field("url",docUrl,Field.Store.COMPRESS,Field.Index.NOT_ANALYZED));
			   doc.add(new Field("docId",new Integer(Math.abs(docUrl.hashCode())).toString(),Field.Store.COMPRESS,Field.Index.NOT_ANALYZED));
			   doc.add(new Field("title",docTitle,Field.Store.COMPRESS,Field.Index.NOT_ANALYZED));
			   doc.add(new Field("content",docContent,Field.Store.NO,Field.Index.ANALYZED));
			return doc;
		}
	}// end Handler*/
	
	/*******
	 * HashCode implementation that equals the java.String.hashCode
	 * but returns long intead of int
	 * @param String s to be hashed
	 * @return hashCode
	 */
	   public long longHashCode(String s)
	   {
		   long hashCode = 0;  
		   int len = s.length();  
		   for (int i = 0; i < len; i++)
		   {
			   hashCode =hashCode + s.charAt(i)*(int)Math.pow(31,len-i);
		   }
		   
		   return hashCode;
	   }
	
	   /**********
	    * Creates a lucene type document with the given attributes and 
	    * add it to an index
	    * @param title
	    * @param url
	    * @param content
	    * @param indexPath
	    */
	   public synchronized void indexDocument(Document doc)
	   {
		   System.out.println("Indexing document");
		   try 
		   {
				if(sNode.getTimer()==-1)
				{
					sNode.setTimer(new Date().getTime());
				}
			   IndexWriter iWriter=sNode.getIndexWriter();

			   iWriter.addDocument(doc);
			   
			   sNode.increaseDocCount();
		   }
		   catch (CorruptIndexException e) 
		   {
			   System.out.println(e.getMessage());
			   e.printStackTrace();
		   }
		   catch (IOException e) 
		   {
			   System.out.println(e.getMessage());
			   e.printStackTrace();
		   }
	   }
	   
	   private boolean checkCorrectness(Document doc,String docContent)
	   {
		   
		   DistributeDocuments distr =new DistributeDocuments(sNode.getMethod());
		   if(sNode.getMethod().equalsIgnoreCase("lh"))
		   {
			   //System.out.println("Cluster level "+ sNode.getClusterLevel());
			   distr.initLH(sNode.getACTIVE_NODES(),sNode.getClusterLevel());   
		   }
		   else if(sNode.getMethod().equalsIgnoreCase("eh"))
		   {
			   distr.initEH(sNode.getCTable());
		   }
		   else if(sNode.getMethod().equalsIgnoreCase("rush"))
		   {
			   distr.initRush(sNode.getACTIVE_NODES());
		   }
		   else if(sNode.getMethod().equalsIgnoreCase("rangepartition"))
		   {
			   distr.initRangepartitioning(sNode.getNodedir(), sNode.getACTIVE_NODES());
		   }
		   else if(sNode.getMethod().equalsIgnoreCase("scaddar"))
		   {
			   distr.initSCADDAR(sNode.getACTIVE_NODES());
		   }
		   else if(sNode.getMethod().equalsIgnoreCase("xfs"))
		   {
			   return true;
		   }
		   
		   int node=distr.findNode(Integer.parseInt(doc.get("docId")));
		   
		   if(node>3)
			   node++;
		   //System.out.println("Old node value "+ node);
		   if(node!=sNode.getNodeNum())
		   {
			   
			   
				try {
					UpdateClusterImageInterface uci = (UpdateClusterImageInterface)Naming.lookup("rmi://129.241.102.111/UpdateClientImage");
					if(sNode.getMethod().equalsIgnoreCase("lh"))
					{
						if(node>3)
							   node--;
						node=linearHashCheck(distr, node,doc);
						uci.adjustClientImage(sNode.getClusterLevel(),sNode.getNodeNum());
						if(node==sNode.getNodeNum())
						{
							return true;
						}
					}
					if(sNode.getMethod().equalsIgnoreCase("rush") || sNode.getMethod().equalsIgnoreCase("scaddar"))
					{
						uci.updateClientImage(sNode.getACTIVE_NODES());
					}
					
					if(sNode.getMethod().equalsIgnoreCase("rangepartition"))
					{
						uci.updateClientImage(sNode.getACTIVE_NODES());
						uci.updateClientDirectory(sNode.getNodedir());
					}
					//else if(sNode.getMethod().equalsIgnoreCase("eh"))
					//{
						//uci.updateCacheTable(sNode.getCTable());
					//}
				} catch (RemoteException e) {
					e.printStackTrace();
				} catch (MalformedURLException e) {
					e.printStackTrace();
				} catch (NotBoundException e) {
					e.printStackTrace();
				}

			   //if(node>3)
				 //  node+=1;
			   //System.out.println("Node value "+node);
				if(node!=sNode.getNodeNum())
				{
					System.out.println("Resending to node "+ node);
					sNode.sendDocument(doc,docContent, node,false);
				}
			   return false;
		   }
		   return true;
	   }
	   
	   private int linearHashCheck(DistributeDocuments distr, int node,Document doc)
	   {
		   System.out.println("Linear hashing check");
		   distr=new DistributeDocuments("LH");
		   distr.initLH(sNode.getACTIVE_NODES(), sNode.getClusterLevel()-1);
		   int nodeCheck=distr.findNode(Integer.parseInt(doc.get("docId")));
		   
		   if((nodeCheck>sNode.getNodeNum()) && (nodeCheck<node))
			   node=nodeCheck;
		   
		   if(node>3)
			   node++;
		   return node;
	   }

}
