/**********************
 * Class responsible for sending documents. Used by both servers and clients
 * ************/

import it.unimi.dsi.io.FastBufferedReader;// Comment out when using on server 
import it.unimi.dsi.lang.MutableString;// Comment out when using on server
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.index.CorruptIndexException;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.queryParser.ParseException;
import org.apache.lucene.queryParser.QueryParser;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.Query;
import org.apache.lucene.search.Searcher;
import org.apache.lucene.search.TopDocs;


import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.io.*;

public class SendDocument
{
	private StorageNode sNode;
	private Socket[] clientSocket;
	private ObjectOutputStream out,clientWriter;
	private String receiver;
	private String filePath="/mnt/d1/hoyum/documents/";
	private String indexPath="/mnt/d1/hoyum/index/";
	private boolean withIndex; // determines if document transport shall 
								//send raw documents or indexed lucene document
	
	

	public SendDocument(int port,StorageNode sNode)
	{
		int localNode;
		this.sNode=sNode;
		this.withIndex=withIndex;
		
		if(sNode!=null)
		{
			localNode=sNode.getNodeNum();
		}
		else
		{
			localNode=-1;
		}
		try {
			clientSocket=new Socket[7];
			int nodenr;
			for(int i=0;i<clientSocket.length;i++)
			{

				if(i==3)
				{
					continue;
				}
				
				nodenr=i+1;
				clientSocket[i]=new Socket("endless0"+nodenr+".idi.ntnu.no",4444);
			}
			
			
		} catch (UnknownHostException e) {
			// 
			e.printStackTrace();
		} catch (IOException e) {
			
			e.printStackTrace();
		}

	}
	
	/******************
	 * Method for sending documents to the cluster. Uses mg4j library which is not used by servers
	 * so this method should be commented out when compiled for the servers.
	 * ****/
	public synchronized void sendFromClient(it.unimi.dsi.mg4j.document.Document doc,int node)
	{
		
		try
		{
			char[] fileArray=new char[18000];
			String title=null;
			//clientWriter=new BufferedWriter(new OutputStreamWriter(clientSocket[node-1].getOutputStream()));
			clientWriter =new ObjectOutputStream(clientSocket[node-1].getOutputStream());
			clientWriter.flush();
			
			Reader fileStream;
			//clientSocket=new Socket(receiver,port);
			//out=new BufferedWriter(new OutputStreamWriter(clientSocket.getOutputStream()));

			FastBufferedReader r=null;
			char prev,l;
			int c;
			r = (FastBufferedReader)doc.content(0);
			MutableString parsedContent=new MutableString();
       		r.readLine(parsedContent);
    		prev = ' ';
    		while( (c = r.read()) != -1) 
    		{
    			l = (char) c;
    			if (prev == ' ' && l == ' ')
    				continue; // vil ikkje ha repeterende mellomrom!
    			if ((prev=='\n' && l == '\n')  || l == '\r' || l=='\t') 
    			{
    				continue;
    			}
    		
    			parsedContent.append(l);
    			prev = l;
		   
    		}
    		String docContent=parsedContent.toString();
    		docContent.trim();
    		int contentLength=docContent.length();
    		
			//fileStream=(Reader)doc.content(0);
			//fileStream.read(fileArray,0,fileArray.length);
    		System.out.println("Title "+doc.title().toString());
    		synchronized(clientWriter)
    		{
    			title=doc.title().toString();
    			title.trim();
    			clientWriter.writeObject(title);
    			clientWriter.writeInt(contentLength);
    			clientWriter.writeObject(doc.uri().toString());
    			clientWriter.writeChars(docContent);
    			clientWriter.flush();
    			
    		}
			
			
			r.close();
			//fileStream.close();
		


		
		
		}
		catch (FileNotFoundException fnf)
		{
			System.out.println(fnf.getMessage());
		}
		catch (IOException ioe)
		{
			System.out.println(ioe.getMessage());
		}

	}// end send()*/
	
	
	public void send(org.apache.lucene.document.Document indexDoc,String content, int node)
	{	

		BufferedReader reader;
		
		String docContent = "";
		int fileByte;
		char[] buffer=new char[1024];
		IndexReader iReader=null;
		IndexWriter iWriter=sNode.getIndexWriter();
		int docnr;
		//org.apache.lucene.document.Document indexDoc;
	
		try
		{
			System.out.println("Socket array "+ node);
			if(node==4)
			{
				System.out.println("Tom node ");
				System.exit(1);
			}
			//out=new BufferedWriter(new OutputStreamWriter(clientSocket[node-1].getOutputStream()));
			out=new ObjectOutputStream(clientSocket[node-1].getOutputStream());
			//FileWriter localWriter = null;
			//localWriter=new FileWriter("/mnt/d1/hoyum/localTmp/"+indexDoc.get("title"));
			iReader=IndexReader.open(indexPath);
			//iReader.reopen();

			//clientSocket=new Socket(receiver,port);
			//out=new BufferedWriter(new OutputStreamWriter(clientSocket.getOutputStream()));
			if(content==null)
			{
			reader=new BufferedReader(new FileReader(filePath+indexDoc.get("title")+".txt"));
				
				
				while((fileByte=reader.read(buffer))!=-1)
				{
					docContent=docContent.concat(new String(buffer));
					
				}
				reader.close();
				deleteDocument(iWriter,indexDoc.get("docId"),indexDoc.get("title"));
			}
			else
			{
				docContent=content;
			}
				
				//System.out.println("Sending title "+ indexDoc.get("title"));
    			synchronized(out)
    			{
    				System.out.println("Sending document to "+node + "docId "+ Math.abs(indexDoc.get("url").hashCode()));
    				out.writeObject(indexDoc.get("title"));
    				out.writeInt(docContent.length());
    				out.writeObject(indexDoc.get("url"));
    				out.writeChars(docContent);
    				out.flush();
    			}	
    			


				//docnr=getDocument(indexDoc.get("docId"),iReader);

				
				//sNode.decreaseDocCount();
			
			//iReader.close();


				
			//fileStream.close();
		

		}
		catch(FileNotFoundException fnf)
		{
			System.out.println(fnf.getMessage());
		}
		catch(IOException io)
		{
			System.out.println(io.getMessage());
		}
		
	}
	
	/**public void sendWithIndex(org.apache.lucene.document.Document indexDoc,String content, int node,String path,boolean fromClient)
	{	

		BufferedReader reader;
		ObjectOutputStream objectWriter;
		
		String docContent = "";
		int fileByte;
		char[] buffer=new char[1024];
		IndexReader iReader=null;
		IndexWriter iWriter=null;
		if(!fromClient)
		{
			iWriter=sNode.getIndexWriter();
		}
		int docnr;
		//org.apache.lucene.document.Document indexDoc;
	
		try
		{
			System.out.println("Socket array "+ node);
			if(node==4)
			{
				System.out.println("Tom node ");
				System.exit(1);
			}
			//out=new BufferedWriter(new OutputStreamWriter(clientSocket[node-1].getOutputStream()));
			objectWriter=new ObjectOutputStream(clientSocket[node-1].getOutputStream());

			//FileWriter localWriter = null;
			//localWriter=new FileWriter("/mnt/d1/hoyum/localTmp/"+indexDoc.get("title"));
			if(path==null)
			{
				iReader=IndexReader.open(indexPath);
			}
			else
			{
				iReader=IndexReader.open(path);
			}
			//iReader.reopen();

			//clientSocket=new Socket(receiver,port);
			//out=new BufferedWriter(new OutputStreamWriter(clientSocket.getOutputStream()));
			if(content==null)
			{
			reader=new BufferedReader(new FileReader(filePath+indexDoc.get("title")+".txt"));
				
				
				while((fileByte=reader.read(buffer))!=-1)
				{
					docContent=docContent.concat(new String(buffer));
					
				}
				reader.close();
				if(!fromClient)
				{
					deleteDocument(iWriter,indexDoc.get("docId"),indexDoc.get("title"));
				}
			}
			else
			{
				docContent=content;
			}
				
				//System.out.println("Sending title "+ indexDoc.get("title"));
				/*synchronized(out)
				{
					out.write(1);
					out.flush();
				}
    		synchronized(objectWriter)
    		{
    			objectWriter.writeObject(indexDoc);
    			objectWriter.writeObject(docContent);
    			objectWriter.flush();


    		System.out.println("Sending document to "+node + "docId "+ Math.abs(indexDoc.get("url").hashCode()));

    		}	
    			


				//docnr=getDocument(indexDoc.get("docId"),iReader);

				
				//sNode.decreaseDocCount();
			
			//iReader.close();


				
			//fileStream.close();
		

		}
		catch(FileNotFoundException fnf)
		{
			System.out.println(fnf.getMessage());
		}
		catch(IOException io)
		{
			System.out.println(io.getMessage());
		}
		
	}**/
	public void closeConnection()
	{
		try {
			for(Socket connection:clientSocket)
			{
				connection.close();
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	/************
	 * Inputs a querystring and a parser and returns a parsed query
	 * @param queryParser
	 * @param querystr
	 * @return
	 **********/
	private Query parseQuery(QueryParser queryParser, String querystr) {
		Query query = null;
		try {
			query = queryParser.parse(querystr);
		} catch (ParseException e) {
			System.out.println("Error parsing query " 
					+ querystr + ": " + e.getMessage());
			return null;
		}
		return query;
	}
	
	private void deleteDocument(IndexWriter iWriter, String docId,String docTitle)
	{
		QueryParser docIdQuery=new QueryParser("docId",new StandardAnalyzer());
		Query query=parseQuery(docIdQuery,docId);
		try {
			iWriter.deleteDocuments(query);
			
			File deleteFile=new File(filePath+docTitle);
			deleteFile.delete();
		} catch (CorruptIndexException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	private int getDocument(String docId,IndexReader iReader)
	{
		QueryParser docIdQuery=new QueryParser("docId",new StandardAnalyzer());
		Searcher searcher=new IndexSearcher(iReader);
		Query query=null;
		TopDocs hits=null;
		int docnr;
		query=parseQuery(docIdQuery,docId);
		System.out.println("Doc Id "+docId);
		try {
			hits=searcher.search(query,1);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		docnr=hits.scoreDocs[0].doc;
		
		return docnr;
		
	}
}
