

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.*;



public class UpdateClusterImage extends UnicastRemoteObject implements UpdateClusterImageInterface {

	private Client client;
	private StorageNode sNode;
	public UpdateClusterImage(Client client) throws RemoteException
	{
		this.client=client;
		sNode=null;
	}
	
	public UpdateClusterImage(StorageNode sNode) throws RemoteException
	{
		this.sNode=sNode;
	}
	public void adjustClientImage(int clusterLevel, int node) throws RemoteException 
	{
		if(clusterLevel>client.getClusterLevel())
		{
			client.setClusterLevel(clusterLevel-1);
			if(node==3)
				node+=1;
			client.setSplitPointer(node+1);
		}
		else if(client.getSplitPointer()>Math.pow(2,client.getClusterLevel()))
		{
			client.setSplitPointer(1);
			client.setClusterLevel(client.getClusterLevel()+1);
		}
	}
	
	public void updateCacheTable(int oldNode,int newNode) throws RemoteException
	{
			client.getCTable().splitNode(oldNode, newNode);
			

	}

	public void updateCacheTable(int oldNode) throws RemoteException 
	{
		sNode.getCTable().splitNode(oldNode,sNode.getNodeNum());
	}
	
	public void updateBuddyNode(CacheTable cTable) throws RemoteException
	{
		sNode.setCTable(cTable);
	}

	public void updateClientImage(int activeNodes) throws RemoteException {
		client.setACTIVE_NODES(activeNodes);
		
	}
	
	public void updateClientDirectory(ArrayList<Integer> directory) throws RemoteException
	{
		client.increaseFailedRecipient();
		client.setDirectory(directory);
	}

		
	




}
